#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h> 
#include <fcntl.h>
#include <linux/kd.h>
#include <linux/types.h>

unsigned char savedleds = 0; 	/* saved led states */
int ttyfd;			/* fd for the tty */

void scrollon(void)
{
        ioctl(ttyfd,KDGETLED,&savedleds);
        ioctl(ttyfd,KDSETLED,savedleds^LED_SCR);
}

void scrolloff(void)
{
        ioctl(ttyfd,KDGETLED,&savedleds);
        ioctl(ttyfd,KDSETLED,savedleds&~LED_SCR);
}

void capson(void)
{
        ioctl(ttyfd,KDGETLED,&savedleds);
        ioctl(ttyfd,KDSETLED,savedleds^LED_CAP);
}

void capsoff(void)
{
        ioctl(ttyfd,KDGETLED,&savedleds);
        ioctl(ttyfd,KDSETLED,savedleds&~LED_CAP);
}

int main(int argc, char *argv[])		
{
FILE *F1 = NULL;
char tty[10] = "/dev/";	/* device name */
int packets[2] = { 0, 0 };
static int last_packets[2] = { 0, 0 };
int skip = 0, dummy;
char line[256] = { '\0' };
char face[256];
char *word = NULL;

fprintf(stderr, "\nnetkbd-1.0 emre@mercan.cmpe.boun.edu.tr\n" );
if (argc<2){
fprintf(stderr, "Arguments missing.\n Example:  \"netkbd tty3 ppp0\" \n");
exit(1);
}

strcat(tty,argv[1]);
if((ttyfd = open(tty,O_RDWR)) < 0) {	
       	fprintf(stderr,"Error opening keyboard %s\n ",tty); 
	exit(1);
}

while (1){

F1 = fopen("/proc/net/dev", "r");
if (F1 == NULL) {
       	fprintf(stderr,"Error using proc "); 
	exit(1);
}
	strcpy(face, "");
	while (!feof(F1)) {
		fgets(line, 256, F1);
		if (feof(F1)) break;
		word = (char *)strtok(line, " ");
		if (word != NULL) {
			strcpy(face, word);
		}
		face[strlen(face)-1]='\0';
		word = (char *)strtok(NULL, " ");
		if (word != NULL) {
			sscanf(word, "%d", &packets[0]);
		}

		for (skip=0; skip < 5; skip++) {
			word = (char *)strtok(NULL, " ");
		}

		if (word != NULL) {
			sscanf(word, "%d", &packets[1]);
		}
		
		if (strcmp(argv[2], face) == 0) {
			if (packets[0]!=last_packets[0]) capson(); else capsoff();
			if (packets[1]!=last_packets[1]) scrollon(); else scrolloff();
			last_packets[0] = packets[0];
			last_packets[1] = packets[1];
		}
	}
fclose(F1);
usleep(100000);
}

}


